/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.enums.EnumAccesslevel;
import de.ship.db.tables.records.VPrivilegeRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VPrivilege extends TableImpl<VPrivilegeRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_privilege</code>
     */
    public static final VPrivilege V_PRIVILEGE = new VPrivilege();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VPrivilegeRecord> getRecordType() {
        return VPrivilegeRecord.class;
    }

    /**
     * The column <code>common_dd.v_privilege.fk_privilege</code>.
     */
    public final TableField<VPrivilegeRecord, Integer> FK_PRIVILEGE = createField(DSL.name("fk_privilege"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_privilege.fk_usnr</code>.
     */
    public final TableField<VPrivilegeRecord, Integer> FK_USNR = createField(DSL.name("fk_usnr"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_privilege.acl</code>.
     */
    public final TableField<VPrivilegeRecord, EnumAccesslevel> ACL = createField(DSL.name("acl"), SQLDataType.VARCHAR.asEnumDataType(EnumAccesslevel.class), this, "");

    /**
     * The column <code>common_dd.v_privilege.read</code>.
     */
    public final TableField<VPrivilegeRecord, Boolean> READ = createField(DSL.name("read"), SQLDataType.BOOLEAN, this, "");

    /**
     * The column <code>common_dd.v_privilege.write</code>.
     */
    public final TableField<VPrivilegeRecord, Boolean> WRITE = createField(DSL.name("write"), SQLDataType.BOOLEAN, this, "");

    /**
     * The column <code>common_dd.v_privilege.execute</code>.
     */
    public final TableField<VPrivilegeRecord, Boolean> EXECUTE = createField(DSL.name("execute"), SQLDataType.BOOLEAN, this, "");

    private VPrivilege(Name alias, Table<VPrivilegeRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VPrivilege(Name alias, Table<VPrivilegeRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_privilege" as  WITH x(p, u, a) AS (
                SELECT gp.fk_privilege,
                   ug.fk_usnr,
                       CASE (gp.square_acl)::text
                           WHEN 'r'::text THEN '001'::bit(3)
                           WHEN 'w'::text THEN '010'::bit(3)
                           WHEN 'rw'::text THEN '011'::bit(3)
                           WHEN 'x'::text THEN '100'::bit(3)
                           WHEN 'rx'::text THEN '101'::bit(3)
                           WHEN 'wx'::text THEN '110'::bit(3)
                           WHEN 'rwx'::text THEN '111'::bit(3)
                           ELSE NULL::"bit"
                       END AS "case"
                  FROM (common_dd.t_core_groupprivilege gp
                    LEFT JOIN common_dd.t_core_usergroup ug ON ((ug.fk_group = gp.fk_group)))
               UNION ALL
                SELECT t_core_userprivilege.fk_privilege,
                   t_core_userprivilege.fk_usnr,
                       CASE (t_core_userprivilege.square_acl)::text
                           WHEN 'r'::text THEN '001'::bit(3)
                           WHEN 'w'::text THEN '010'::bit(3)
                           WHEN 'rw'::text THEN '011'::bit(3)
                           WHEN 'x'::text THEN '100'::bit(3)
                           WHEN 'rx'::text THEN '101'::bit(3)
                           WHEN 'wx'::text THEN '110'::bit(3)
                           WHEN 'rwx'::text THEN '111'::bit(3)
                           ELSE NULL::"bit"
                       END AS "case"
                  FROM common_dd.t_core_userprivilege
               )
        SELECT fk_privilege,
           fk_usnr,
           acl,
           ((acl)::text ~~ '%r%'::text) AS read,
           ((acl)::text ~~ '%w%'::text) AS write,
           ((acl)::text ~~ '%x%'::text) AS execute
          FROM ( SELECT x.p AS fk_privilege,
                   x.u AS fk_usnr,
                       CASE bit_or(x.a)
                           WHEN '001'::"bit" THEN 'r'::common_dd.enum_accesslevel
                           WHEN '010'::"bit" THEN 'w'::common_dd.enum_accesslevel
                           WHEN '011'::"bit" THEN 'rw'::common_dd.enum_accesslevel
                           WHEN '100'::"bit" THEN 'x'::common_dd.enum_accesslevel
                           WHEN '101'::"bit" THEN 'rx'::common_dd.enum_accesslevel
                           WHEN '110'::"bit" THEN 'wx'::common_dd.enum_accesslevel
                           WHEN '111'::"bit" THEN 'rwx'::common_dd.enum_accesslevel
                           ELSE NULL::common_dd.enum_accesslevel
                       END AS acl
                  FROM x
                 WHERE (x.a IS NOT NULL)
                 GROUP BY x.p, x.u) outerselect;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_privilege</code> table reference
     */
    public VPrivilege(String alias) {
        this(DSL.name(alias), V_PRIVILEGE);
    }

    /**
     * Create an aliased <code>common_dd.v_privilege</code> table reference
     */
    public VPrivilege(Name alias) {
        this(alias, V_PRIVILEGE);
    }

    /**
     * Create a <code>common_dd.v_privilege</code> table reference
     */
    public VPrivilege() {
        this(DSL.name("v_privilege"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VPrivilege as(String alias) {
        return new VPrivilege(DSL.name(alias), this);
    }

    @Override
    public VPrivilege as(Name alias) {
        return new VPrivilege(alias, this);
    }

    @Override
    public VPrivilege as(Table<?> alias) {
        return new VPrivilege(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VPrivilege rename(String name) {
        return new VPrivilege(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VPrivilege rename(Name name) {
        return new VPrivilege(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VPrivilege rename(Table<?> name) {
        return new VPrivilege(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VPrivilege where(Condition condition) {
        return new VPrivilege(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VPrivilege where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VPrivilege where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VPrivilege where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VPrivilege where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VPrivilege where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VPrivilege where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VPrivilege where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VPrivilege whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VPrivilege whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
